--charge la carte
map = {

	{0; 0; 0; 1; 2; 2; 2; 2; 2; 2; 2; 2; 0; 0; 0; };
	{0; 0; 1; 1; 2; 2; 2; 2; 2; 2; 2; 2; 2; 0; 0; };
	{0; 1; 1; 1; 2; 2; 2; 2; 2; 2; 2; 2; 2; 2; 0; };
	{1; 1; 1; 1; 2; 2; 2; 2; 2; 2; 2; 2; 2; 2; 2; };
	{1; 1; 1; 1; 2; 4; 4; 4; 4; 4; 4; 2; 2; 2; 2; };
	{1; 1; 1; 1; 2; 4; 1; 1; 1; 1; 4; 2; 2; 2; 2; };
	{1; 1; 1; 1; 3; 3; 1; 1; 1; 1; 4; 2; 2; 2; 2; };
	{1; 1; 1; 1; 2; 4; 1; 1; 1; 1; 4; 2; 2; 2; 2; };
	{1; 1; 1; 1; 3; 3; 1; 1; 1; 1; 4; 2; 2; 2; 2; };
	{1; 1; 1; 1; 2; 4; 1; 1; 1; 1; 4; 2; 2; 2; 2; };
	{1; 1; 1; 1; 2; 4; 4; 4; 4; 4; 4; 2; 2; 2; 2; };
	{1; 1; 1; 1; 2; 2; 2; 2; 2; 2; 2; 2; 2; 2; 2; };
	{0; 1; 1; 1; 2; 2; 2; 2; 2; 2; 2; 2; 2; 2; 0; };
	{0; 0; 1; 1; 2; 2; 2; 2; 2; 2; 2; 2; 2; 0; 0; };
	{0; 0; 0; 1; 2; 2; 2; 2; 2; 2; 2; 2; 0; 0; 0; };
}

--enregistre la largeur et la hauteur de la table/carte (inutilisé)
map.w = #map[1]
map.h = #map

--taille des carreaux
--[[
tw = 0x80
th = 0x40
--]]
tw = 100
th = 50

--charge l'image
grass = gr.newImage("grass.png")
water = gr.newImage("water.png")
bridge = gr.newImage("bridge.png")
wall = gr.newImage("wall.png")

function map:draw()
	
	--pour chaque y
	for ky, _ in ipairs(self) do

		--pour chaque x
		for kx, v in ipairs(self[ky]) do

			--origine isométrie
			local ox = (kx - ky) * tw/2
			local oy = (kx + ky) * th/2
			
			--player offset
			ox, oy = offset(ox, oy)
			
			--coordonne le losange
			local x1, x2, x3, x4 = ox + tw/2, ox + tw, ox + tw/2, ox
			local y1, y2, y3, y4 = oy, oy + th/2, oy + th, oy + th/2

			local color
			
			--charge la couleur du terrain
			if v == 0 then
				fill = {0x00, 0x00, 0x00, 0x00}
				line = {0xFF, 0x00, 0x00, 0x20}
			end
			
			--terre
			if v == 1 then
				fill = {0x20, 0x60, 0x20}
				line = {0x40, 0xC0, 0x40, 0x20}
				
				gr.draw(grass, ox, oy)
			end
			
			--eau
			if v == 2 then
				fill = {0x00, 0x40, 0x80}
				line = {0x00, 0x80, 0xFF, 0x20}
				
				gr.draw(water, ox, oy+7)
			end
			
			if v == 3 then
				fill = {0x40, 0x20, 0x10}
				line = {0x80, 0x40, 0x20, 0x20}
				
				gr.draw(bridge, ox, oy)
			end
			
			if v == 4 then
				fill = {0x20, 0x20, 0x20}
				line = {0x40, 0x40, 0x40, 0x20}
				
				gr.draw(wall, ox, oy)
			end
--[[
			gr.setColor(fill)
			gr.quad("fill", x1, y1, x2, y2, x3, y3, x4, y4)
			
			gr.setLineWidth(2)
			gr.setColor(line)
			gr.quad("line", x1, y1, x2, y2, x3, y3, x4, y4)
--]]
		end
	end	
end

function map:info()

	if love.keyboard.isDown("tab") then

		--pour chaque y
		for ky, _ in ipairs(self) do

			--pour chaque x
			for kx, v in ipairs(self[ky]) do

				--origine isométrie
				local ox = (kx - ky) * tw/2
				local oy = (kx + ky) * th/2
				
				--player offset
				ox, oy = offset(ox, oy)
				
				--coordonne le losange
				local x1, x2, x3, x4 = ox + tw/2, ox + tw, ox + tw/2, ox
				local y1, y2, y3, y4 = oy, oy + th/2, oy + th, oy + th/2

				gr.setLineWidth(1)
				gr.setColor(0xFF, 0xFF, 0xFF)

				--encadre les carreaux
				gr.quad("line", x1, y1, x2, y2, x3, y3, x4, y4)

				--affiche le type de terrain et les coordonnées
				gr.print(v .. "\n" .. kx .. "," .. ky, ox+tw/3, oy+th/3)
			end
		end
	end
end
--camera offset
function offset(ox, oy)

	return
	
		ox + getW/2 - player.draw_x - tw/2,
		oy + getH/2 - player.draw_y - th/2
end
