--initialise le joueur
player = {}

--enregistre sa position sur la grille
player.grid_x = 1
player.grid_y = 8

player.dest_x = (player.grid_x - player.grid_y) * tw/2
player.dest_y = (player.grid_x + player.grid_y) * th/2

player.draw_x = player.dest_x
player.draw_y = player.dest_y
player.draw_s = 0x10

function player:update(dt)

	--met à jour la position du dessin
	self.draw_x = self.draw_x - ((self.draw_x - self.dest_x) * self.draw_s * dt)
	self.draw_y = self.draw_y - ((self.draw_y - self.dest_y) * self.draw_s * dt)
end

function player:move(dx, dy)

	--enregistre le type de la case visée
	local nextGrid = map[self.grid_y + dy][self.grid_x + dx]
	
	--si la case visée est de l'herbe ou un pont
	if nextGrid == 1 or nextGrid == 3 then
		---[[ alors déplacement de 1 case
		
		self.grid_x = self.grid_x + dx
		self.grid_y = self.grid_y + dy
		
		self.dest_x = (self.grid_x - self.grid_y) * tw/2
		self.dest_y = (self.grid_x + self.grid_y) * th/2
		--]]
	end
end

function player:draw()

	--dessine le personnage
	ox = self.draw_x
	oy = self.draw_y

	--camera offset
	ox, oy = offset(ox, oy)

	--prepare les coordonnées du losange
	local x1, x2, x3, x4 = ox + tw/2, ox + tw, ox + tw/2, ox
	local y1, y2, y3, y4 = oy, oy + th/2, oy + th, oy + th/2

	--dessine le losange
	gr.setColor(0xFF, 0xFF, 0xFF, 0x20)
	gr.quad("fill", x1, y1 + th/6, x2 - tw/6, y2, x3, y3 - th/6, x4 + tw/6, y4)
end

function player:info()
	---[[ DEBUG
	gr.setColor(0xFF, 0xFF, 0xFF)

	if ke.isDown("tab") then
	
		gr.print(
			
			--affiche les coordonnées
			"dest_x : "   .. self.dest_x ..
			"\ndest_y : " .. self.dest_y ..
			--affiche la grille traversée
			"\ngrid_x : " .. self.grid_x ..
			"\ngrid_y : " .. self.grid_y,
			0, 0
		)

	else

		--affiche la commande de debug + FPS
		gr.print("tab -> debug\nFPS = " .. love.timer.getFPS(), 0, 0)
	end
	--]]
end
